#
# uspk07.rb
#
# $Id: uspk07.rb,v 1.1 2000/11/22 14:36:03 keiko Exp $
#

require "narray"
require "dcl"

include DCL
include Math


N = 200
M = 10
x = NArray.sfloat(N)
y = NArray.sfloat(N)
a = NArray.sfloat(M)

#-----------------------------------------------------------------------
dt = 1.0/(N-1)
for j in 0..M-1
  jj = j*2+1
  a[j] = (-1.0)**(j+1) *2.0/(jj*PI)
end

x = x.indgen * dt
for i in 0..N-1
  t = dt*i*2*PI
  yy = 0.0
  for j in 0..M-1
    jj = j*2+1
    yd = a[j]*cos(jj*t)
    yy = yy + yd
  end
  y[i] = yy*2.0
end

#-----------------------------------------------------------------------
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

grfrm

#      --- X AXIS ---
uzrset('UYUSER', 0.0)
uscset('CXSIDE', 'U')

#      --- Y AXIS ---
uziset('IROTLYL', 1)
uziset('ICENTYL', 0)
uscset('CYSIDE', 'L')

#      --- etc. ---
uziset('INNER', -1)
uscset('CBLKT', '[]')

ussttl('TIME', 'SEC', 'VOLTAGE', 'mV')
usgrph(N, x, y)

grcls

